﻿package  
{
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.text.AntiAliasType;
	import org.papervision3d.materials.MovieMaterial;
	import org.papervision3d.view.layer.ViewportLayer;
	
	import CubeTextFace;
	
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.core.math.Sphere3D;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.objects.primitives.Sphere;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.objects.primitives.Plane;
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.core.*;
	
	import caurina.transitions.Tweener;
	/**
	 * ...
	 * @author Jeroen Oliemans
	 */
	public class PaperVisionPoetry  extends MovieClip
	{
		
		private var viewPort:Viewport3D;
		private var scene:Scene3D;
		private var camera:Camera3D;
		private var renderer:BasicRenderEngine;
		private var plane:Plane;
		private var _colors:Array;
		private var _cubeArray:Array;
		private var _poem:Array;
		
		private var _face:flash.display.Sprite
		
		private var _txtFormat:TextFormat;
		
		public static const OFFSET_X:Number = 140;
		public static const OFFSET_Y:Number = 140;
		private var _currentY:Number = 140;
		private var _currentX:Number = -140;
		private var _tcount:Number = 0;
		private var pl:PointLight3D;
		
		public static var SLOW_FRAME_RATE:int = 10;
		
		public function PaperVisionPoetry() 
		{
			init();
			stage.frameRate = SLOW_FRAME_RATE;
			trace( "init" );
		}
		
		private function init():void
		{
			makeData();
			loadFont();
		}
		
		private function enterFrameHandler(e:Event):void 
		{
			renderScene();
		}
		
		private function make3DScene():void
		{
			viewPort = new Viewport3D( 600, 600);
			viewPort.interactive = true;
			
			addChild( viewPort );
			
			scene = new Scene3D();
			camera = new Camera3D();
			camera.zoom = 11;
			camera.focus = 100;
			renderer = new BasicRenderEngine();
			makeLights();
			addObjects();
		}
		
		private function loadFont():void
		{
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.INIT, fontLoaded);
			loader.load(new URLRequest("assets/gill.swf"));
		}
		
		private function fontLoaded(e:Event):void
		{
			_txtFormat = new TextFormat("gill", 24, 0x000000);
			_txtFormat.align = TextFormatAlign.CENTER;	
			make3DScene();
		}
		
		
		private function addObjects():void
		{
			_cubeArray = new Array();
			for (var j:int = 0; j < _poem.length; j++) 
			{
				var mmArray:Array = new Array();
				for (var i:int = 0; i < _poem[j].words.length; i++) 
				{	
					//var f2:CubeTextFace = new CubeTextFace( 0xff6600, _poem[j].words[i], _txtFormat );
					var color:int = Math.abs( Math.random() * _colors.length );
					var f2:CubeTextFace = new CubeTextFace( _colors[color], _poem[j].words[i], _txtFormat );
					stage.addChild( f2 );
					f2.visible = false;
					f2.cacheAsBitmap = true;
					f2.useHandCursor = true;
					
					var f2mm:MovieMaterial = new MovieMaterial( f2 );
					f2mm.smooth = true;
					f2mm.interactive = true;
					f2mm.animated = true;
					mmArray.push( f2mm );
				}
				// set faces
				var cml:MaterialsList = new MaterialsList();
				cml.addMaterial( mmArray[0], "front" );
				cml.addMaterial( mmArray[1], "top" );
				cml.addMaterial( mmArray[2], "back" );
				cml.addMaterial( mmArray[3], "bottom" );
				cml.addMaterial( mmArray[4], "left" );
				cml.addMaterial( mmArray[5], "right" );
				
				var cube:Cube = new Cube( cml, 100, 100, 100, 10, 10, 10 );
				cube.name = "cube1";
				cube.rotationX = (Math.random()*20) - 10;
				cube.rotationY = (Math.random()*20) - 10;
				cube.rotationZ = (Math.random()*20) - 10;
				
				
				if ( _tcount >= 3 )
				{
					_tcount = 0;
					_currentY -= OFFSET_Y;
				}
				_currentX = -140 + ( OFFSET_X * _tcount );
				
				cube.y = _currentY;
				cube.x = _currentX;
				
				_tcount++ ;
				
				scene.addChild( cube );
				
				//clear materials array
				for (var n:int = 0; n < mmArray.length; n++) 
				{
					mmArray[n] = null;
				}

				var cube1Layer:ViewportLayer = viewPort.getChildLayer(cube, true, true);
				
				_cubeArray.push( cube1Layer );
			
			}	
			addCubeHandlers();
		}
		
		private function addCubeHandlers():void
		{
			for (var i:int = 0; i < _cubeArray.length; i++) 
			{
				_cubeArray[i].buttonMode = true;
				_cubeArray[i].useHandCursor = true;
				_cubeArray[i].addEventListener( MouseEvent.MOUSE_OUT, mouseOuthandler );
				_cubeArray[i].addEventListener( MouseEvent.CLICK, cubeClickHandler );
				_cubeArray[i].addEventListener( MouseEvent.MOUSE_OVER, mouseOverhandler );
			}
			stage.addEventListener( Event.ENTER_FRAME, enterFrameHandler );
		}
				
		private function cubeClickHandler(e:MouseEvent):void 
		{
			var currViewPort:ViewportLayer = e.currentTarget as ViewportLayer;
			Tweener.addTween(currViewPort.displayObject3D, {localRotationY : ( currViewPort.displayObject3D.localRotationY + 90 ), time:1, transition:"easeOutCubic"});
		}
		
		private function mouseOuthandler(e:MouseEvent):void 
		{
			e.currentTarget.filters = [];
			stage.frameRate = SLOW_FRAME_RATE;
		}
		
		private function mouseOverhandler(e:MouseEvent):void 
		{
			stage.frameRate = 30;
			e.currentTarget.filters = [new GlowFilter( 0xfefefe, 0.5, 15, 15, 20 ) ];
		}
		
		private function makeLights():void
		{
			pl = new PointLight3D( true );
			pl.x = 1000;
			pl.y = 1000;
			pl.z = -1000;
			scene.addChild( pl );
		}
		
		private function renderScene():void
		{
			renderer.renderScene( scene, camera, viewPort );
		}
		
		private function makeData():void
		{
			_poem = new Array();

			_poem[0] = {  words: new Array( "I", "HARD", "WANT", "THIS", "LUCK", "BETTER" ) };
			_poem[1] = {  words: new Array( "YOU", "ME", "TREE", "WATER", "RAVE", "SOUND" ) };
			_poem[2] = {  words: new Array( "DELAY", "WE", "SUCKS", "EMO", "BUTTER", "LOVE" ) };
			_poem[3] = {  words: new Array( "SUN", "NO", "WORK", "MAX", "FLASH", "SURF" ) };
			_poem[4] = {  words: new Array( "SHEEP", "YES", "TEST", "CARE", "BREAD", "BOOM" ) };
			_poem[5] = {  words: new Array( "GRASS", "WHAT", "SLEEP", "SERVE", "BEER", "NICE" ) };
			_poem[6] = {  words: new Array( "TWO", "SEE", "SEVEN", "GOAL", "SUGAR", "CHILD" ) };
			_poem[7] = {  words: new Array( "STREET", "SKATE", "SEA", "EMO", "TENDER", "LOVE" ) };
			_poem[8] = {  words: new Array( "WAY", "FEEL", "US", "EMO", "ANGER", "LIVE" ) };
			
			
			_colors = new Array();
			_colors.push( 0xff6600 );
			_colors.push( 0xff6699 );
			_colors.push( 0xff6633 );
			_colors.push( 0xff3399 );
			_colors.push( 0xff33ff );
			_colors.push( 0xff3366 );
			_colors.push( 0xff3300 );
		}
	}
}